%include "asm_io.inc"

segment .data
msg1 db "Hello,please enter your name: ", 0
msg2 db "Enter how many times you want your name to be printed(50-100)", 0
welcome_msg db "Welcome, ", 0
 error_msg db "Invalid input. Please enter a number between 50 and 100.", 0


section .bss
  name resb 100    ; reserve space for the name
  num resd 10     ; reserve space for the number

segment .text
global asm_main
asm_main:

  
pusha
  ; Print message for user's name
mov eax, msg1
call print_string
call print_nl


; Read name
    mov eax, 3
    mov ebx, 0
    mov ecx, name
    mov edx, 100
    int 0x80
    call print_nl        ; Add newline after user input


  ; Print message for second integer
prmopt_num:
  mov eax, msg2
  call print_string
  call read_int
  mov [num], eax

    ; Check value
  cmp eax, 50
  jle error
  cmp eax, 100
  jg error

  ; Move the input number to a loop counter
  mov ecx, eax

; print_name
  print_name:
  mov eax, welcome_msg
  call print_string
  mov eax, name
  call print_string
  call print_nl
  dec ecx  ; Decrement counter for loop
  cmp ecx, 0  ; Check if loop count is zero
  jne print_name  ; Jump back to loop if not zero
  jmp exit


  exit:
  popa
  ret


error:
  mov eax, 4
  mov ebx, 1
  mov ecx, error_msg
  mov edx, 53       ; Length of the error message
  int 0x80          ; Print error message
  jmp prmopt_num    ; Jump back to the second prompt after error